/*+
|                                               |
|     Trigger: DTULTATU_STEP_GRUPO              |  
|     Tabela : STEP_GRUPO                       |
|                                               |
|     Criao:                                  |
|     19/07/2007 - Luiz Passos                  |
|                                               |
+*/

create or replace TRIGGER DTULTATU_STEP_GRUPO
BEFORE INSERT OR UPDATE OR DELETE
ON STEP_GRUPO FOR EACH ROW
BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUSTEPGRU := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDGRUPOCARGO,0) <> NVL(:NEW.CDGRUPOCARGO,0)) OR
           (NVL(:OLD.NRSEQSTEP,0) <> NVL(:NEW.NRSEQSTEP,0)) OR
           (NVL(:OLD.VRSALASTEP,0) <> NVL(:NEW.VRSALASTEP,0)) THEN
         :NEW.DTULTATUSTEPGRU := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('STEP_GRUPO'  , '', 'CDGRUPOCARGO='||:OLD.CDGRUPOCARGO||';NRSEQSTEP='||:OLD.NRSEQSTEP||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE STEP_GRUPO MODIFY DTULTATUSTEPGRU DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_STEP_GRUPO','5.01.008'); END;
/

